【Tsinsen】1228 飞飞侠【并查集优化最短路】

2024-09-05 13:58

本文主要是介绍【Tsinsen】1228 飞飞侠【并查集优化最短路】,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接:A1228. 飞飞侠

#include <bits/stdc++.h>
using namespace std ;typedef long long LL ;#define clr( a , x ) memset ( a , x , sizeof a )const int MAXN = 155 ;
const LL INF = 1e18 ;struct Node {LL dis ;int x , y ;Node () {}Node ( LL dis , int x , int y ) : dis ( dis ) , x ( x ) , y ( y ) {}bool operator < ( const Node& a ) const {return dis > a.dis ;}
} ;int a[MAXN][MAXN] ;
int b[MAXN][MAXN] ;
int p[MAXN][MAXN] ;
int sx[3] , sy[3] ;
LL d[MAXN][MAXN] ;
LL ans[3] ;
int n , m ;int F ( int p[] , int x ) {return p[x] == x ? x : ( p[x] = F ( p , p[x] ) ) ;
}void dij ( int o ) {for ( int i = 1 ; i <= n ; ++ i ) {for ( int j = 1 ; j <= m + 1 ; ++ j ) {d[i][j] = INF ;p[i][j] = j ;}}priority_queue < Node > q ;q.push ( Node ( b[sx[o]][sy[o]] , sx[o] , sy[o] ) ) ;p[sx[o]][sy[o]] = sy[o] + 1 ;d[sx[o]][sy[o]] = 0 ;while ( !q.empty () ) {Node u = q.top () ;q.pop () ;int l1 = a[u.x][u.y] , x = max ( 1 , u.x - l1 ) , y = min ( n , u.x + l1 ) ;for ( int i = x ; i <= y ; ++ i ) {int l2 = l1 - abs ( u.x - i ) , L = max ( 1 , u.y - l2 ) , R = min ( m , u.y + l2 ) ;for ( int j = F ( p[i] , L ) ; j <= R ; j = F ( p[i] , j ) ) {q.push ( Node ( u.dis + b[i][j] , i , j ) ) ;d[i][j] = u.dis ;p[i][j] = j + 1 ;}}}
}void solve () {for ( int i = 1 ; i <= n ; ++ i ) {for ( int j = 1 ; j <= m ; ++ j ) {scanf ( "%d" , &a[i][j] ) ;}}for ( int i = 1 ; i <= n ; ++ i ) {for ( int j = 1 ; j <= m ; ++ j ) {scanf ( "%d" , &b[i][j] ) ;}}for ( int i = 0 ; i < 3 ; ++ i ) {scanf ( "%d%d" , &sx[i] , &sy[i] ) ;}ans[0] = ans[1] = ans[2] = 0 ;for ( int i = 0 ; i < 3 ; ++ i ) {dij ( i ) ;for ( int j = 0 ; j < 3 ; ++ j ) {ans[j] += d[sx[j]][sy[j]] ;}}LL res = min ( ans[0] , min ( ans[1] , ans[2] ) ) ;if ( res >= INF ) printf ( "NO\n" ) ;else {printf ( "%c\n" , ans[0] == res ? 'X' : ( ans[1] == res ? 'Y' : 'Z' ) ) ;printf ( "%I64d\n" , res ) ;}
}int main () {while ( ~scanf ( "%d%d" , &n , &m ) ) solve () ;return 0 ;
}

这篇关于【Tsinsen】1228 飞飞侠【并查集优化最短路】的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1139151

相关文章

Vue3 的 shallowRef 和 shallowReactive:优化性能

大家对 Vue3 的 ref 和 reactive 都很熟悉,那么对 shallowRef 和 shallowReactive 是否了解呢? 在编程和数据结构中,“shallow”(浅层)通常指对数据结构的最外层进行操作,而不递归地处理其内部或嵌套的数据。这种处理方式关注的是数据结构的第一层属性或元素,而忽略更深层次的嵌套内容。 1. 浅层与深层的对比 1.1 浅层(Shallow) 定义

HDFS—存储优化(纠删码)

纠删码原理 HDFS 默认情况下,一个文件有3个副本,这样提高了数据的可靠性,但也带来了2倍的冗余开销。 Hadoop3.x 引入了纠删码,采用计算的方式,可以节省约50%左右的存储空间。 此种方式节约了空间,但是会增加 cpu 的计算。 纠删码策略是给具体一个路径设置。所有往此路径下存储的文件,都会执行此策略。 默认只开启对 RS-6-3-1024k

使用opencv优化图片(画面变清晰)

文章目录 需求影响照片清晰度的因素 实现降噪测试代码 锐化空间锐化Unsharp Masking频率域锐化对比测试 对比度增强常用算法对比测试 需求 对图像进行优化,使其看起来更清晰,同时保持尺寸不变,通常涉及到图像处理技术如锐化、降噪、对比度增强等 影响照片清晰度的因素 影响照片清晰度的因素有很多,主要可以从以下几个方面来分析 1. 拍摄设备 相机传感器:相机传

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

MySQL高性能优化规范

前言:      笔者最近上班途中突然想丰富下自己的数据库优化技能。于是在查阅了多篇文章后,总结出了这篇! 数据库命令规范 所有数据库对象名称必须使用小写字母并用下划线分割 所有数据库对象名称禁止使用mysql保留关键字(如果表名中包含关键字查询时,需要将其用单引号括起来) 数据库对象的命名要能做到见名识意,并且最后不要超过32个字符 临时库表必须以tmp_为前缀并以日期为后缀,备份

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i

hdu 3790 (单源最短路dijkstra)

题意: 每条边都有长度d 和花费p,给你起点s 终点t,要求输出起点到终点的最短距离及其花费,如果最短距离有多条路线,则输出花费最少的。 解析: 考察对dijkstra的理解。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstrin

poj 3255 次短路(第k短路) A* + spfa 或 dijkstra

题意: 给一张无向图,求从1到n的次短路。 解析: A* + spfa 或者 dijkstra。 详解见上一题:http://blog.csdn.net/u013508213/article/details/46400189 本题,spfa中,stack超时,queue的效率最高,priority_queue次之。 代码: #include <iostream>#i